unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, URLmon, OleServer, MSXML2_TLB;

type
  TForm1 = class(TForm)
    ButtonKonec: TButton;
    ButtonDalsi: TButton;
    ButtonZpet: TButton;
    Notebook: TNotebook;
    LabeledEditServer: TLabeledEdit;
    LabeledEditPort: TLabeledEdit;
    Label1: TLabel;
    Splitter1: TSplitter;
    LabelZ: TLabel;
    LabelDo: TLabel;
    LabelPres: TLabel;
    ComboBoxZ: TComboBox;
    ComboBoxDo: TComboBox;
    ComboBoxPres: TComboBox;
    EditCas: TEdit;
    LabelCas: TLabel;
    Label3: TLabel;
    EditPrestupu: TEdit;
    LabelSpojeni: TLabel;
    EditSpojeni: TEdit;
    TreeView: TTreeView;
    LabelKecy: TLabel;
    LabelPrani: TLabel;
    procedure ButtonKonecClick(Sender: TObject);
    procedure ButtonDalsiClick(Sender: TObject);
    procedure ButtonZpetClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    a : IXMLDOMDocument;
    procedure test_gui;
    procedure SpojeniDoStromu(el:IXMLDOMElement);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ButtonKonecClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.test_gui;
begin
  ButtonZpet.Enabled := Notebook.PageIndex<>0;
  ButtonDalsi.Enabled := Notebook.PageIndex<>Notebook.Pages.Count-1
end;

function param(j, h:string):string;
var i:integer;
begin
  for i:=1 to length(h) do if h[i]=' ' then h[i]:='+';
  if (h<>'') then result:=j+'='+h+'&' else result := '';
end;

procedure TForm1.SpojeniDoStromu(el:IXMLDOMElement);
var spoj, vlak, stan : IXMLDOMNode;
    root, spoj_t, vlak_t : TTreeNode;
    a : IXMLDOMNode;
    s : string;
    cas_od, cas_do, z, doo : string;
    prestupu : integer;

begin
  spoj := el.firstChild;
  TreeView.Items.Clear;
  root := TreeView.Items.Add(NIL, ComboBoxZ.Text+' - '+ComboBoxDo.Text);
  while spoj<>NIL do
  begin
    spoj_t := TreeView.Items.AddChild(root, 'Spojeni');
    prestupu := 0;
    cas_od := '?';  cas_do := '?';
    vlak := spoj.firstChild;
    while vlak<>NIL do
    begin
      vlak_t := TreeView.Items.AddChild(spoj_t, 'Vlak '+vlak.attributes.getNamedItem('cislo').text);
      z := '?'; doo := '?';
      stan := vlak.firstChild;
      while (stan<>NIL) do
      begin
        if (stan.nodeName='Stanice') then
        begin
          if (z='?') then z:=stan.text;
          doo := stan.text;

          s := '';
          a := stan.attributes.getNamedItem('prijezd');
          if (a<>NIL) then
          begin
             s:=s + a.text;
             cas_do := a.text;
          end else s:=s+'         ';
          s := s + '   ';
          a :=stan.attributes.getNamedItem('odjezd');
          if (a<>NIL) then
          begin
            s:=s + a.text;
            if (cas_od='?') then cas_od := a.text;
          end else s:=s+'         ';
          s := s + '      '+stan.text;
          TreeView.Items.AddChild(vlak_t,s);
        end
        else if (stan.nodeName='Poznamka') then
        begin
          TreeView.Items.AddChild(vlak_t,'Pozn: '+stan.text);
        end else ShowMessage('Cbybny format spojeni');
        stan := stan.nextSibling;
      end;
      vlak_t.Text := vlak_t.Text + '    '+z+' - '+doo;
      vlak := vlak.nextSibling;
      prestupu := prestupu + 1;
    end;
    spoj_t.Text := 'Odjezd: '+cas_od+'  Pjezd: '+cas_do;
    dec(prestupu);
    if prestupu = 0 then spoj_t.Text := spoj_t.Text + '   bez pestup' else spoj_t.Text := spoj_t.Text +  '   Pestup: '+inttostr(prestupu);
    spoj := spoj.nextSibling;
  end;
  if root.Count = 0 then TreeView.Items.AddChild(root, 'Spojen nebylo nalezeno');
  root.Expand(false);
end;

procedure TForm1.ButtonDalsiClick(Sender: TObject);
var url : string;
    ret : integer;
    el : IXMLDOMElement;
    n   : IXMLDOMNode;
    start, stop : Cardinal;
begin
  if (Notebook.PageIndex=0) then
  begin
    url := 'http://'+LabeledEditServer.text+':'+LabeledEditPort.text+'/SeznamStanic';
    ret := URLDownloadToFile(NIL, pchar(url), 'temp.xml', 0, NIL);
    if (ret = 0) then
    begin
      a := CoDOMDocument.create;
      a.load('temp.xml');
      el := a.documentElement;
      if (el.tagName<>'SeznamStanic') then
      begin
        ShowMessage('Nepodailo se nast seznam stanic ze serveru');
      end else
      begin
        n := el.firstChild;
        while (n<>NIL) do
        begin
         ComboBoxZ.Items.Add(n.text);
         n := n.nextSibling;
        end;
        Notebook.PageIndex := Notebook.PageIndex + 1;
        ComboBoxDo.Items.Assign(ComboBoxZ.Items);
        ComboBoxPres.Items.Assign(ComboBoxZ.Items);
        ComboBoxPres.Items.Insert(0,'--- pes nen zadno ---');

        ComboBoxZ.ItemIndex := 0;
        ComboBoxDo.ItemIndex := 0;
        ComboBoxPres.ItemIndex := 0;

        ComboBoxZ.ItemIndex := ComboBoxZ.Items.IndexOf('Plzen hl.n.');
        ComboBoxDo.ItemIndex := ComboBoxDo.Items.IndexOf('Praha hl.n.');
      end;
    end else
    ShowMessage('Nepodailo se nast seznam stanic ze serveru');
  end else
  if (Notebook.PageIndex=1) then
  begin
    if (ComboBoxZ.Text = ComboBoxDo.Text) then
     ShowMessage('Poten a clov stanice nesm bt shodn')
    else begin
      url := 'http://'+LabeledEditServer.text+':'+LabeledEditPort.text+'/NajdiSpojeni?';
      url := url + param('odkud', ComboBoxZ.text);
      url := url + param('kam', ComboBoxDo.text);
      url := url + param('odjezd', EditCas.Text);
      url := url + param('prestupy', EditPrestupu.Text);
      url := url + param('spojeni', EditSpojeni.Text);
      if ComboBoxPres.Text[1]<>'-' then url := url + param('pres', ComboBoxPres.text);
      start := GetTickCount;
      ret := URLDownloadToFile(NIL, pchar(url), 'temp.xml', 0, NIL);
      stop := GetTickCount;
      if (ret = 0) then
      begin
        a := CoDOMDocument.create;
        a.load('temp.xml');
        el := a.documentElement;
        if (el=NIL) or (el.tagName<>'Spojeni') then
        begin
          if el.tagName='Chyba' then
            ShowMessage('Chyba: '+el.text)
          else
            ShowMessage('Nepodailo se zjistit spojeni ze serveru');
        end else
        begin
          SpojeniDoStromu(el);
          TreeView.Items[0].Text := TreeView.Items[0].Text + '     (Hledno '+IntToStr(stop-start)+'ms)'; 
          Notebook.PageIndex := Notebook.PageIndex + 1;
        end;
      end else ShowMessage('Server neodpovedel');
    end;
  end;
  test_gui;
end;

procedure TForm1.ButtonZpetClick(Sender: TObject);
begin
  Notebook.PageIndex := Notebook.PageIndex - 1;
  test_gui;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Notebook.ActivePage := 'Server';
  test_gui;
end;

end.
