// JZData.cpp: implementation of the JZData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JZServer.h"
#include "JZData.h"



CString JZData::parse(CString fname) {
	int i;

	CStdioFile rady;
	if (!rady.Open(fname,CFile::modeRead|CFile::shareDenyWrite))
		return "Nemohu otevt soubor s dy " + fname +"!";

	//hashovaci tabulky a pole
	staniceHash.InitHashTable(19997);
	linkyHash.InitHashTable(19997);
	staniceNazvy.SetSize(0,1024);
	linkyNazvy.SetSize(0,1024);

	//faze prvni - nacteni nazvu stanic a linek
	CString line;
	char data[4096];
	int num;
	while (rady.ReadString(line)) {
		if (sscanf(line," <Linka cislo=\"%[^\"]",data)) {
			if (!linkyHash.Lookup(data,num)) {
				num=linkyNazvy.Add(data);
				linkyHash.SetAt(data,num);
			}
		}
		if (sscanf(line," <Stanice%*[^>]>%[^<]",data)) {
			if (!staniceHash.Lookup(data,num)) {
				num=staniceNazvy.Add(data);
				staniceHash.SetAt(data,num);
			}
		}
	}

	//setridime
	staniceNazvySort();
	staniceHash.RemoveAll();
	for (i=staniceNazvy.GetSize()-1;i>=0;i--) staniceHash.SetAt(staniceNazvy[i],i);

	linkyNazvySort();
	linkyHash.RemoveAll();
	for (i=linkyNazvy.GetSize()-1;i>=0;i--) linkyHash.SetAt(linkyNazvy[i],i);

	//a finalni beh
	rady.SeekToBegin();
	linky.SetSize(linkyNazvy.GetSize());
	stanice.SetSize(staniceNazvy.GetSize());

	int linka;
	while (rady.ReadString(line)) {
		if (sscanf(line," <Linka cislo=\"%[^\"]",data)) {
			linkyHash.Lookup(data,linka);
		} else if (num=-1,sscanf(line," <Stanice %n",&num),num>=0) {
			int offset=num;

			int odj=-1,pri=-1,h,m;
			//prijezd
			if (num=-1,sscanf((LPCSTR)line+offset,"prijezd=\"%d:%d\" %n",&h,&m,&num),num>=0) {
				pri=h*60+m;
				offset+=num;
			}
			//odjezd
			if (num=-1,sscanf((LPCSTR)line+offset,"odjezd=\"%d:%d\"%n",&h,&m,&num),num>=0) {
				odj=h*60+m;
				offset+=num;
			}
			//stanice
			sscanf((LPCSTR)line+offset,">%[^<]",data);
			//a pridej
			staniceHash.Lookup(data,num);
			linky[linka].stanice.Add(JZLinka::JZLinka_Stanice(num,pri,odj));
			if (odj!=-1) stanice[num].odjezdy.Add(JZStanice::JZStanice_Linka(odj%(24*60),linka));
		} else if (sscanf(line," <Poznamka>%[^<]",data)) {
			linky[linka].pozn.Add(data);
		}		
	}

	for (i=stanice.GetSize()-1;i>=0;i--) stanice[i].odjezdySort();

	return "";
}

void JZStanice::odjezdySort(void) {
	if (odjezdy.GetSize()) qsort(&odjezdy[0],odjezdy.GetSize(),sizeof(JZStanice_Linka),cmp);
}
int JZStanice::cmp(const void *e1,const void *e2) {
	return ((JZStanice::JZStanice_Linka *)e1)->cas - ((JZStanice::JZStanice_Linka *)e2)->cas;
}

void JZData::staniceNazvySort(void) { sort(staniceNazvy); }
void JZData::linkyNazvySort(void) { sort(linkyNazvy); }
void JZData::sort(CStringArray &what) {	
	if (what.GetSize())	qsort(&what[0],what.GetSize(),sizeof(CString),cmp); 
}
int JZData::cmp(const void *e1,const void *e2) {
	return ((CString *)e1)->Compare(*(CString *)e2);
}
