// JZServer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "JZServer.h"
#include "JZServerDlg.h"
#include "JZServerConfDlg.h"
#include "JZServerHttp.h"
#include "JZData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJZServerApp

BEGIN_MESSAGE_MAP(CJZServerApp, CWinApp)
	//{{AFX_MSG_MAP(CJZServerApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJZServerApp construction

CJZServerApp::CJZServerApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CJZServerApp object

CJZServerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CJZServerApp initialization

BOOL CJZServerApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	
	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif


	// Nacteni konfigurace
	CStdioFile conf;
	int port;
	CString rady;

	if (conf.Open("JZServer.ini",CFile::modeRead)) {
		conf.ReadString(rady);
		port=atoi(rady);
		rady=rady.Mid(rady.Find(' ')+1);
		conf.Close();
	} else {
		rady="JZServer.xml";
		port=80;
	}

	// Nastaveni konfigurace
	CJZServerConfDlg cnfDlg;

	cnfDlg.m_intPort=port;
	cnfDlg.m_strRady=rady;
	if (cnfDlg.DoModal()!=IDOK) return FALSE;
	port=cnfDlg.m_intPort;
	rady=cnfDlg.m_strRady;

	if (!conf.Open("JZServer.ini",CFile::modeCreate|CFile::modeWrite)) {
		AfxMessageBox("Nelze otevt soubor JZServer.ini pro zpis!");
	} else {
		CString line;
		line.Format("%d %s",port,rady);
		conf.WriteString(line);
		conf.Close();
	}

	// Vyvoreni okna
	CJZServerDlg dlg;
	m_pMainWnd = &dlg;	

	// Spusteni serveru
	CJZServerHttp *data=new CJZServerHttp();
	data->port=port;
	data->rady=rady;
	CWinThread *server=AfxBeginThread(JZServerHttp,data);

	// Spusteni okna
	dlg.DoModal();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
