// JZServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "JZServer.h"
#include "JZServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJZServerDlg dialog

CJZServerDlg::CJZServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJZServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJZServerDlg)
	m_strLog = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_WAITING);
}

void CJZServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJZServerDlg)
	DDX_Text(pDX, IDC_LOG, m_strLog);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJZServerDlg, CDialog)
	//{{AFX_MSG_MAP(CJZServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_SHOW, OnTrayShow)
	ON_MESSAGE(WM_TRAYCLICK,OnTrayClick)
	ON_MESSAGE(WM_ICON_WORKING,OnIconWorking)
	ON_MESSAGE(WM_ICON_DONE,OnIconDone)
	ON_MESSAGE(WM_LOG,OnLog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJZServerDlg message handlers

BOOL CJZServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SHOW_ICON(IDI_WAITING,"");
	OnIconDone(NULL,NULL);

	trayMenu.LoadMenu(IDM_TRAYMENU);	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJZServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CJZServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJZServerDlg::OnCancel() 
{
	this->ShowWindow(SW_HIDE);
}


void CJZServerDlg::OnTrayShow() 
{
	ShowWindow(SW_SHOW);
	SetForegroundWindow();
}

BOOL CJZServerDlg::DestroyWindow() 
{
	HIDE_ICON(IDI_WAITING,"JZServer se ukonuje...");
	trayMenu.DestroyMenu();
	
	return CDialog::DestroyWindow();
}

LRESULT CJZServerDlg::OnTrayClick(WPARAM wParam, LPARAM lParam) {
	if (WM_LBUTTONDBLCLK == (UINT)lParam) OnTrayShow();
	if (WM_RBUTTONDOWN != (UINT)lParam) return 0;

	POINT pt;
	GetCursorPos(&pt);	
	trayMenu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTALIGN|TPM_BOTTOMALIGN,pt.x,pt.y,this);	
	return 0;
}

LRESULT CJZServerDlg::OnIconWorking(WPARAM wParam, LPARAM lParam) {
	UPDATE_ICON(IDI_WORKING,"JZServer zpracovv dotaz...");
	return 0;
}

LRESULT CJZServerDlg::OnIconDone(WPARAM wParam, LPARAM lParam) {
	UPDATE_ICON(IDI_WAITING,"JZServer ek na dotaz...");
	return 0;
}

LRESULT CJZServerDlg::OnLog(WPARAM wParam, LPARAM lParam) {
	UpdateData(TRUE);
	m_strLog.Insert(0,CTime::GetCurrentTime().Format("%Y-%m-%d %H:%M:%S: ")+(LPCSTR)wParam+"\r\n");
	UpdateData(FALSE);
	return 0;
}
