#include "StdAfx.h"
#include "JZServer.h"
#include "JZServerDlg.h"
#include "JZServerHttp.h"

#include "Socket.h"
#include "JZData.h"
#include "JZSluzby.h"

struct ServantData {
	SOCKET socket;
	JZData *rady;
};

#define LOG(text) { CString logtmp; logtmp.Format text; dlg->SendMessage(WM_LOG,(WPARAM)(LPCSTR)logtmp,NULL); }

CString Word(CString &str,char delimiter) {
	int i;
	if (i=str.Find(delimiter),i==-1) {
		CString ret=str;
		str="";
		return ret;
	}
	CString ret=str.Left(i);
	str=str.Mid(i+1);
	return ret;
}

UINT JZServerHttpServant (LPVOID param) {
	ServantData *data=(ServantData *)param;
	CJZServerDlg *dlg=(CJZServerDlg *) AfxGetApp()->GetMainWnd();
	Socket client(data->socket);

	
	// logging promenne
	CString log;
	DWORD start=GetTickCount();
	LOG(("%d - Navzno spojen.",(int)data->socket));
	dlg->SendMessage(WM_ICON_WORKING);


	// nacti pozadavek
	CString line,tmp;
	client.ReadLine(line);
	while (client.ReadLine(tmp) && (tmp.TrimLeft(),tmp.TrimRight(),tmp.GetLength())) {}
	
	// naparsuj pozadavek
	CString get=Word(line,' ');
	CString urlparams=Word(line,' ');
	CString url=Word(urlparams,'?');
	CString http=Word(line,' ');
	CString error;

	CString odkud,kam,pres;
	int odkud_id,kam_id,pres_id;
	int odjezd,prestupy,spojeni;

	//defaultni parametry
	CTime now=CTime::GetCurrentTime();
	odjezd=now.GetHour()*60 + now.GetMinute();
	prestupy=0;
	spojeni=5;

	//zkontroluj pozadavek
	if (get!="GET") error="Ocekavane slovo GET nebylo nalezeno!";
	if (http.GetLength()<5 || http.Left(5)!="HTTP/") error.Format("Protokol %s neni podporovan!",http);
	if (url=="/") {} //Mainpage
	else if (url=="/SeznamStanic") {} //Seznam stanic
	else if (url=="/NajdiSpojeni") { //Spojeni
		int mam_odkud=0,mam_kam=0;

		CString par,h;
		while (par=Word(urlparams,'='),h=Word(urlparams,'&'),par.GetLength()) {
			if (!h.GetLength()) continue;
			for (int i=0;i<h.GetLength();i++) if (h[i]=='+') h.SetAt(i,' ');

			if (par=="odkud") { odkud=h; mam_odkud=1; } 
			else if (par=="kam") { kam=h; mam_kam=1; }
			else if (par=="pres") pres=h;
			else if (par=="odjezd") {
				int oh,om;
				if (sscanf(h,"%d:%d",&oh,&om)!=2) 
				if (sscanf(h,"%d%%3A%d",&oh,&om)!=2) 
				if (sscanf(h,"%dh%d",&oh,&om)!=2)
				if (h.GetLength()!=4 || sscanf(h,"%02d%02d",&oh,&om)!=2)
				error.Format("Odjezd \"%s\" je ve spatnem formatu!",h);

				if (!error.GetLength()) odjezd=oh*60+om;
			}
			else if (par=="prestupy") prestupy=atoi(h);
			else if (par=="spojeni") spojeni=atoi(h);
			else {
				error.Format("Neznamy parametr \"%s\" v /NajdiSpojeni!",par);
				break;
			}
		}

		//kontrola parametru
		pres_id=-1;

		if (error.GetLength()!=0) {}//zuzo
		else if (!mam_odkud) error="Chybi parametr odkud v /NajdiSpojeni!";
		else if (!data->rady->staniceHash.Lookup(odkud,odkud_id)) error.Format("Parametr odkud \"%s\" neodpovida zadne stanici!",odkud);

		else if (!mam_kam) error="Chybi parametr kam v /NajdiSpojeni!";
		else if (!data->rady->staniceHash.Lookup(kam,kam_id)) error.Format("Parametr kam \"%s\" neodpovida zadne stanici!",kam);

		else if (pres.GetLength() && !data->rady->staniceHash.Lookup(pres,pres_id)) error.Format("Parametr pres \"%s\" neodpovida zadne stanici!",pres);

		else if (odjezd < 0 || odjezd > 24*60) error.Format("Parametr odjezd je mimo rozsah!");
		else if (spojeni < 0) error.Format("Parametr spojeni \"%d\" je mimo rozsah!",spojeni);
		else if (prestupy < 0) error.Format("Parametr prestupy \"%d\" je mimo rozsah!",prestupy);
	} else error.Format("Nepodporovane url %s!",url);

	if (error.GetLength()) {
		LOG(("%d - Pi parsovn dolo k chyb: %s",(int)data->socket,error));

		error.Insert(0,"<Chyba>");
		error+="</Chyba>";
		client.WriteLine("HTTP/1.0 200 OK\r\nContent-type: text/xml\r\n");
		client.WriteLine(error);
	} else { //ve v podku, jdi do toho

		if (url=="/") { //Mainpage
			LOG(("%d - Zobrazuji hlavn nabdku.",(int)data->socket));
			client.WriteLine(http+" 200 OK\r\nContent-type: text/html\r\n");

			HlavniStranka(client);
		}
		if (url=="/SeznamStanic") {
			LOG(("%d - Zasln seznamu vech stanic.",(int)data->socket));
			client.WriteLine(http+" 200 OK\r\nContent-type: text/xml\r\n");

			SeznamStanic(client,data->rady);
		}
		if (url=="/NajdiSpojeni") {
			LOG(("%d - Hledn spojen z %s do %s.",(int)data->socket,odkud,kam));
			client.WriteLine(http+" 200 OK\r\nContent-type: text/xml\r\n");

			NajdiSpojeni(client,data->rady,odkud_id,kam_id,pres_id,odjezd,prestupy,spojeni);
		}
	}

	LOG(("%d - Ukoneno spojen [%d ms].",(int)data->socket,GetTickCount()-start));
	dlg->SendMessage(WM_ICON_DONE);
	client.Close();
	delete data;
	return 0;
}

UINT JZServerHttp (LPVOID param) {
	::Sleep(500);

	CJZServerHttp *data=(CJZServerHttp *)param;
	CJZServerDlg *dlg=(CJZServerDlg *) AfxGetApp()->GetMainWnd();

	//spusteni
	DWORD start=GetTickCount();
	LOG(("Probh inicializace serveru.",data->port));

	//nacteni radu
	LOG(("Natm jzdn dy %s.",data->rady));
	JZData *rady=new JZData();
	CString err=rady->parse(data->rady);
	if (err.GetLength()) {
		dlg->MessageBox("Nelze nast jzdn dy: " + err,"CHYBA",MB_OK|MB_ICONSTOP);
		dlg->EndDialog(IDOK);
		return 0;
	}

	//nateno
	LOG(("Natn jzdnch d dokoneno [%d ms].",GetTickCount()-start));
	Socket server;
	if (!server.CreateListening(data->port)) {
		dlg->MessageBox("Nemohu vytvoit sov socket na zadanm portu!","CHYBA",MB_ICONSTOP|MB_OK);
		dlg->EndDialog(IDOK);
		return 0;
	}

	//and go
	LOG(("Server sputn na portu %d.",data->port));
	dlg->ShowWindow(SW_HIDE);

	ServantData *client=new ServantData();
	while (client->socket=server.Accept()) {
		client->rady=rady;
		AfxBeginThread(JZServerHttpServant,client);
		client=new ServantData();
	}
	return 0;
}