#include <stdafx.h>
#include "JZServer.h"
#include "JZSluzby.h"
#include "JZSluzbyHledac.h"

//this is just a speedup
class QuickBuffer {
public:
	QuickBuffer() {buffer.SetSize(0,32768);}
	void Append(const char *str) { while (*str) buffer.Add(*str++); }
	void Append(const char *str,int len) { for (int i=len-1;i>=0;i--) buffer.Add(*str++); }
	void Finalize() { buffer.Add(0); }
	operator const char *() {return &buffer[0];}
private:
	CArray<char,char> buffer;
};

void HlavniStranka(Socket &s) {
	QuickBuffer b;
	
	CFile file;
	if (file.Open("JZServer.html",CFile::modeRead)) {
		char c;
		while (file.Read(&c,1)) b.Append(&c,1);
		b.Finalize();
		file.Close();
	} else {
		HRSRC page=::FindResource(NULL,MAKEINTRESOURCE(IDR_MAINPAGE),RT_HTML);
		DWORD size=::SizeofResource(NULL,page);
		HGLOBAL data=::LoadResource(NULL,page);
		LPSTR ptr=(LPSTR)::LockResource(data);
		b.Append(ptr,size);
		b.Finalize();
	}

	s.WriteLine((LPCSTR)b);
}

void SeznamStanic(Socket &s,JZData *rady)
{
	QuickBuffer b;

	b.Append("<SeznamStanic>\r\n");
	for (int i=0;i<rady->staniceNazvy.GetSize();i++) {
		b.Append("  <Stanice>");
		b.Append(rady->staniceNazvy[i]);
		b.Append("</Stanice>\r\n");
	}
	b.Append("</SeznamStanic>");
	b.Finalize();
	s.WriteLine((LPCSTR)b);
}


void NajdiSpojeni(Socket &s,JZData *rady,int odkud,int kam,int pres,short odjezd,int prestupy,int spojeni)
{
	QuickBuffer b;
	CString text;
#define FormatAppend(a) {text.Format a;b.Append(text);}

	b.Append("<Spojeni>\r\n");

	SpojInfo *res=(SpojInfo *)_alloca(sizeof(SpojInfo)*(prestupy+1));
	int *pocatecni=(int *)_alloca(sizeof(int)*spojeni);

	for (int spoj=0;spoj<spojeni;spoj++) {
		int res_len=Hledej(odkud,pres,kam,odjezd,prestupy,rady,res);

		if (res_len==-1) break;
		for (int k=0;k<spoj;k++) if (pocatecni[k]==res[0].vlak) break;
		if (k<spoj) break;
		pocatecni[spoj]=res[0].vlak;
		
		b.Append("  <Spoj>\r\n");
		for (k=0;k<res_len;k++) {
			int vlak=res[k].vlak;
			FormatAppend(("    <Linka cislo=\"%s\">\r\n",rady->linkyNazvy[vlak]));

			int zas_len=rady->linky[vlak].stanice.GetSize();
			for (int zas=0;zas<zas_len && rady->linky[vlak].stanice[zas].id!=res[k].from;zas++) {}
			for (;zas<zas_len && (zas==0 || rady->linky[vlak].stanice[zas-1].id!=res[k].to);zas++) {
				b.Append("      <Stanice");
				if (rady->linky[vlak].stanice[zas].prijezd != -1) FormatAppend((" prijezd=\"%02d:%02d\"",rady->linky[vlak].stanice[zas].prijezd/60,rady->linky[vlak].stanice[zas].prijezd%60));
				if (rady->linky[vlak].stanice[zas].odjezd != -1) FormatAppend((" odjezd=\"%02d:%02d\"",rady->linky[vlak].stanice[zas].odjezd/60,rady->linky[vlak].stanice[zas].odjezd%60));
				FormatAppend((">%s</Stanice>\r\n",rady->staniceNazvy[rady->linky[vlak].stanice[zas].id]));
				if (k==0 && rady->linky[vlak].stanice[zas].id==res[k].from) 
					odjezd=(rady->linky[vlak].stanice[zas].odjezd+1)%(24*60);
			}
			for (int pozn=0;pozn<rady->linky[vlak].pozn.GetSize();pozn++)
				FormatAppend(("      <Poznamka>%s</Poznamka>\r\n",rady->linky[vlak].pozn[pozn]));
			
			b.Append("    </Linka>\r\n");
		}
		b.Append("  </Spoj>\r\n");
	}

	b.Append("</Spojeni>");
	b.Finalize();
	s.WriteLine((LPCSTR)b);
}
