// Socket.cpp: implementation of the Socket class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JZServer.h"
#include "Socket.h"

Socket::Socket() :s(NULL) {}

Socket::Socket(SOCKET s) {this->s=s;}

Socket::~Socket() {if (s) Close();}

bool Socket::CreateListening(int port) {
	s=socket(AF_INET,SOCK_STREAM,0);
	if (s==INVALID_SOCKET) return false;

	sockaddr_in sin;
	sin.sin_family=AF_INET;
	sin.sin_port=htons(port);
	sin.sin_addr.S_un.S_addr=INADDR_ANY;
	if (bind(s,(const sockaddr *)&sin,sizeof(sin))) return false;
	if (listen(s,5)) return false;
	return true;
}

SOCKET Socket::Accept() {
	SOCKET ret=accept(s,NULL,NULL);
	return ret == INVALID_SOCKET ? NULL : ret;
}

void Socket::Close() {
	shutdown(s,SD_SEND);
	if (s) closesocket(s);
}

bool Socket::ReadLine(CString &line) {
	char c;
	int nb;
	line="";
	while (nb=recv(s,&c,1,0),nb && nb!=SOCKET_ERROR && c!='\n') if (c!='\r') line+=c;
	return !((nb==0 || nb==SOCKET_ERROR) && (line.GetLength()==0));
}

void Socket::WriteLine(const char *line) {
	int len=strlen(line),acc;
	do {
		acc=send(s,line,len,0);
		if (acc<=0) break;
		len-=acc;
		line+=acc;
	} while (len);
	send(s,"\r\n",2,0);
}
